local _, AT = ...

local Utils = AT.Utils

local FrameMessageBox = {}
FrameMessageBox.frame = nil

AT.FrameMessageBox = FrameMessageBox

function FrameMessageBox:Init()
  local frame = CreateFrame('Frame', nil, UIParent, 'BasicFrameTemplate')
  frame:SetFrameStrata('TOOLTIP')
  frame:RegisterForDrag('LeftButton')
  frame:EnableMouse(true)
  frame:SetMovable(true)
  frame:SetScript('OnDragStart', frame.StartMoving)
  frame:SetScript('OnDragStop', frame.StopMovingOrSizing)

  frame.scrollFrame = CreateFrame('ScrollFrame', nil, frame, 'InputScrollFrameTemplate')
  frame.scrollFrame.EditBox.cursorOffset = 0
  frame.scrollFrame.CharCount:Hide() 
  frame.scrollFrame:ClearAllPoints()
  frame.scrollFrame:SetPoint('TOPLEFT', frame.Bg, 'TOPLEFT', 10, -10)
  frame.scrollFrame:SetPoint('BOTTOMRIGHT', frame.Bg, 'BOTTOMRIGHT', -13, 10)

  self.frame = frame
end

function FrameMessageBox:Show(aHeadline, aText)
  if self.frame == nil then
    self:Init()
  end

  local frame = self.frame

  local resW, resH = Utils:GetResolution()

  frame:SetSize(resW / 2, resH / 2)
  frame:ClearAllPoints()
  frame:SetPoint('CENTER')

  frame.TitleText:SetText(aHeadline)

  frame.scrollFrame.EditBox:SetText(aText)
  frame.scrollFrame.EditBox:SetWidth(frame:GetWidth())
  frame.scrollFrame.EditBox:SetFontObject('ChatFontNormal')
  frame.scrollFrame.EditBox:SetCursorPosition(0)

  frame:Show()
end
